*+
*+
*+    Source Module => H:\DLOADS\FTP\TEMP\TEMP\MENU.PRG
*+
*+    Contents: Function HaceMenu()
*+              Function AbreSubMenu()
*+              Function CierraSubMenu()
*+
*+    Reformatted by Click! on May-8-1997 at 12:32 am
*+
*+

#Include "INKEY.CH"

/***************************************************************************
 * Funcion   : HaceMenu (Para Clipper 5.X)                                 *
 * Proposito : Muestra un menu tipo PullDown en pantalla                   *
 * Autor     : Heberto Villavicencio                                       *
 * Fecha     : 09/02/97                                                    *
 * Parametros: myMenu1   = Array que contiene los titulos de cada submenu  * 
 *             myMenu2   = Array que contiene las opciones de cada submenu *
 *             mLin      = Linea donde se desplega el menu                 *
 *             mCol      = Columna donde se desplega el menu               *
 *             mColor0   = Color de los titulos de cada submenu            *
 *             mColor1   = Color normal de las opciones de cada submenu    *
 *             mColor2   = Color resaltado de la opcion seleccionada       *
 *             mColor3   = Color del recuadro                              *
 *             mColor4   = Color de la letra de seleccion                  *
 *                                                                         *
 *             HaceMenu devuelve el numero de la opcion seleccionada de la *
 *             siguiente forma:                                            *
 *                 SubMenu Seleccionado --> xxxx --> Opcion del submenu    *
 * Este archivo debe ser enlazado utilizando la libreria SAMPLES.LIB       *
 * que viene con clipper                                                   *
 *                                                                         *
 * Cualquier comentario o sugerencia puedes enviarla a hvilla@ven.net      *
 ***************************************************************************/

*+
*+
*+    Function HaceMenu()
*+
*+    Called from ( pr_menu.prg  )   1 - function cierrasubmenu()
*+
*+
*+
function HaceMenu( myMenu1, myMenu2, mLin, mCol, mColor0, mColor1, mColor2, mColor3, mColor4 )

static mMenuProcesado := .f.
static mTitulosCol    := {}
static mMenuLin       := 1
static mSMCol         := {}
static mSMLin         := 1
static mSMLet         := {}

local mI
local mL
local mFondo
local mMaxTam
local mOldLin
local OldC    := setcursor()
local mScreen

if !mMenuProcesado

   for mI := 1 to len( myMenu1 )

      aadd( mTitulosCol, iif( mI == 1, mCol, mTitulosCol[ mI - 1 ] + len( myMenu1[ mI - 1 ] ) + 2 ) )
      aadd( mSMCol, iif( mI == 1, mCol, mSMCol[ mI - 1 ] + len( myMenu1[ mI - 1 ] ) + 2 ) )
      aadd( mSMLet, {} )

      mMaxTam := 0

      for mL := 1 to len( myMenu2[ mI ] )
         aadd( mSMLet[ mI ], at( '~', myMenu2[ mI, mL ] ) )
         myMenu2[ mI, mL ] := subst( myMenu2[ mI, mL ], 1, mSMLet[ mI, mL ] - 1 ) + subst( myMenu2[ mI, mL ], mSMLet[ mI, mL ] + 1 )
         if len( myMenu2[ mI, mL ] ) > mMaxTam
            mMaxTam := len( myMenu2[ mI, mL ] )
         endif
      next mL

      @ mLin, mTitulosCol[ mI ] say myMenu1[ mI ] color mColor0

      do while mSMCol[ mI ] + mMaxTam > 76
         mSMCol[ mI ] --
      enddo

      for mL := 1 to len( myMenu2[ mI ] )
         if myMenu2[ mI, mL ] = "\-"
            myMenu2[ mI, mL ] := "\-"
         else
            myMenu2[ mI, mL ] := myMenu2[ mI, mL ] + space( mMaxTam - len( myMenu2[ mI, mL ] ) )
         endif
      next mL

   next mI

   mMenuProcesado := .t.

endif

@ mLin, mTitulosCol[ mMenuLin ] say myMenu1[ mMenuLin ] color mColor2        
mFondo := AbreSubMenu( mLin + 1, mSMCol[ mMenuLin ], myMenu2[ mMenuLin ], mColor1, mColor2, mColor3, mColor4, mSMLet[ mMenuLin ] )

setcursor( 0 )

do while mI != 27

   @ mLin + mSMLin + 1, mSMCol[ mMenuLin ] + 1 say myMenu2[ mMenuLin, mSMLin ] color mColor2        
   mI := inkey( 0 )

   @ mLin + mSMLin + 1, mSMCol[ mMenuLin ] + 1 say myMenu2[ mMenuLin, mSMLin ] color mColor1        
   if mSMLet[ mMenuLin, mSMLin ] != 0
      @ mLin + mSMLin + 1, mSMCol[ mMenuLin ] + mSMLet[ mMenuLin, mSMLin ] say subst( myMenu2[ mMenuLin, mSMLin ], mSMLet[ mMenuLin, mSMLin ], 1 ) color mColor4        
   endif

   do case
   case mI == K_LEFT
      @ mLin, mTitulosCol[ mMenuLin ] say myMenu1[ mMenuLin ] color mColor0        
      CierraSubMenu( mFondo )
      mMenuLin --
      if mMenuLin < 1 
         mMenuLin := len( myMenu1 )
      endif
      @ mLin, mTitulosCol[ mMenuLin ] say myMenu1[ mMenuLin ] color mColor2        
      mFondo := AbreSubMenu( mLin + 1, mSMCol[ mMenuLin ], myMenu2[ mMenuLin ], mColor1, mColor2, mColor3, mColor4, mSMLet[ mMenuLin ] )
      mSMLin := 1
   case mI == K_RIGHT
      @ mLin, mTitulosCol[ mMenuLin ] say myMenu1[ mMenuLin ] color mColor0        
      CierraSubMenu( mFondo )
      mMenuLin ++
      if mMenuLin > len( myMenu1 ) 
         mMenuLin := 1
      endif
      @ mLin, mTitulosCol[ mMenuLin ] say myMenu1[ mMenuLin ] color mColor2        
      mFondo := AbreSubMenu( mLin + 1, mSMCol[ mMenuLin ], myMenu2[ mMenuLin ], mColor1, mColor2, mColor3, mColor4, mSMLet[ mMenuLin ] )
      mSMLin := 1
   case mI == K_DOWN
      mSMLin ++
      if mSMLin > len( myMenu2[ mMenuLin ] ) 
         mSMLin := 1
      endif
      if myMenu2[ mMenuLin, mSMLin ] == "\-"
         mSMLin ++
         if mSMLin > len( myMenu2[ mMenuLin ] ) 
            mSMLin := 1
         endif
      endif
   case mI == K_UP
      mSMLin --
      if mSMLin < 1 
         mSMLin := len( myMenu2[ mMenuLin ] )
      endif
      if myMenu2[ mMenuLin, mSMLin ] == "\-"
         mSMLin --
         if mSMLin < 1 
            mSMLin := len( myMenu2[ mMenuLin ] )
         endif
      endif
   case mI == K_ENTER
      @ mLin + mSMLin + 1, mSMCol[ mMenuLin ] + 1 say myMenu2[ mMenuLin, mSMLin ] color mColor2        
      do EJECUTA with alltrim( str( mMenuLin, 2, 0 ) ) + alltrim( str( mSMLin, 2, 0 ) )
   case mI > 47 .and. mI < 123
      mOldLin := 1
      do while mOldLin <= len( myMenu2[ mMenuLin ] )
         if upper( chr( mI ) ) == upper( subst( myMenu2[ mMenuLin, mOldLin ], mSMLet[ mMenuLin, mOldLin ], 1 ) )
            mSMLin := mOldLin
            keyboard chr( 13 )
            exit
         endif
         mOldLin ++
      enddo
   case mI == K_ESC
      setcursor( OldC )
      return ( NIL )
   endcase

enddo

return ( NIL )

*+
*+
*+    Function AbreSubMenu()
*+
*+    Called from ( menu.prg     )   3 - function hacemenu()
*+
*+
*+
function AbreSubMenu( mLin, mCol, mSubMenu, mC1, mC2, mC3, mC4, mLetras )

local mI
local mRetorna := {}

aadd( mRetorna, savescreen( mLin, mCol, mLin + len( mSubMenu ) + 2, mCol + len( mSubMenu[ 1 ] ) + 2 ) )

BoxShadow( mLin, mCol, mLin + len( mSubMenu ) + 1, mCol + len( mSubMenu[ 1 ] ) + 1 )

setcolor( mC1 )     // Normal
@ mLin, mCol Clear to mLin + len( mSubMenu ) + 1, mCol + len( mSubMenu[ 1 ] ) + 1

setcolor( mC3 )     // Recuadro
@ mLin, mCol to mLin + len( mSubMenu ) + 1, mCol + len( mSubMenu[ 1 ] ) + 1

for mI := 1 to len( mSubMenu )
   if mSubMenu[ mI ] == "\-"
      @ mLin + mI, mCol say chr( 195 ) + replicate( chr( 196 ), len( mSubMenu[ 1 ] ) ) + chr( 180 ) color mC1        
   else
      @ mLin + mI, mCol + 1 say mSubMenu[ mI ] color mC1        
   endif
   if mLetras[ mI ] != 0
      @ mLin + mI, mCol + mLetras[ mI ] say subst( mSubMenu[ mI ], mLetras[ mI ], 1 ) color mC4        
   endif
next mI

aadd( mRetorna, mLin )
aadd( mRetorna, mCol )
aadd( mRetorna, mLin + len( mSubMenu ) + 2 )
aadd( mRetorna, mCol + len( mSubMenu[ 1 ] ) + 2 )

return ( mRetorna )

*+
*+
*+    Function CierraSubMenu()
*+
*+    Called from ( menu.prg     )   2 - function hacemenu()
*+
*+
*+
function CierraSubMenu( mVentana )

restscreen( mVentana[ 2 ], mVentana[ 3 ], mVentana[ 4 ], mVentana[ 5 ], mVentana[ 1 ] )

return ( NIL )


*+ EOF: MENU.PRG
